"use strict";
var pipeMiddlewares = function (_a) {
    var head = _a[0], tail = _a.slice(1);
    return function (req, res, next) {
        if (!head) {
            // empty middlewares array
            return;
        }
        var nextMiddleware = function (err) {
            return err ? next(err) : pipeMiddlewares(tail)(req, res, next);
        };
        head(req, res, !tail.length ? next : nextMiddleware);
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = pipeMiddlewares;
//# sourceMappingURL=pipeMiddlewares.js.map